(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('nu-lazy', ['exports', '@angular/common', '@angular/core', 'rxjs', 'rxjs/operators'], factory) :
    (factory((global.nu = global.nu || {}, global.nu.lazy = {}),global.ng.common,global.ng.core,global.rxjs,global.rxjs.operators));
}(this, (function (exports,i1,i0,rxjs,operators) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LazyService = /** @class */ (function () {
        // tslint:disable-next-line:no-any
        function LazyService(doc) {
            this.doc = doc;
            this.list = {};
            this.cached = {};
            this._notify = new rxjs.BehaviorSubject([]);
        }
        Object.defineProperty(LazyService.prototype, "events", {
            get: /**
             * @return {?}
             */ function () {
                return this._notify.asObservable().pipe(operators.share(), operators.filter(function (ls) { return ls.length !== 0; }));
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        LazyService.prototype.clear = /**
         * @return {?}
         */
            function () {
                this.list = {};
                this.cached = {};
            };
        /**
         * @param {?} paths
         * @return {?}
         */
        LazyService.prototype.load = /**
         * @param {?} paths
         * @return {?}
         */
            function (paths) {
                var _this = this;
                if (!Array.isArray(paths)) {
                    paths = [paths];
                }
                /** @type {?} */
                var promises = [];
                paths.forEach(function (path) {
                    if (path.endsWith('.js')) {
                        promises.push(_this.loadScript(path));
                    }
                    else {
                        promises.push(_this.loadStyle(path));
                    }
                });
                return Promise.all(promises).then(function (res) {
                    _this._notify.next(res);
                    return Promise.resolve(res);
                });
            };
        /**
         * @param {?} path
         * @param {?=} innerContent
         * @return {?}
         */
        LazyService.prototype.loadScript = /**
         * @param {?} path
         * @param {?=} innerContent
         * @return {?}
         */
            function (path, innerContent) {
                var _this = this;
                return new Promise(function (resolve) {
                    if (_this.list[path] === true) {
                        resolve(_this.cached[path]);
                        return;
                    }
                    _this.list[path] = true;
                    /** @type {?} */
                    var onSuccess = function (item) {
                        _this.cached[path] = item;
                        resolve(item);
                    };
                    // tslint:disable-next-line:no-any
                    /** @type {?} */
                    var node = ( /** @type {?} */(_this.doc.createElement('script')));
                    node.type = 'text/javascript';
                    node.src = path;
                    node.charset = 'utf-8';
                    if (innerContent) {
                        node.innerHTML = innerContent;
                    }
                    if (node.readyState) {
                        // IE
                        node.onreadystatechange = function () {
                            if (node.readyState === 'loaded' || node.readyState === 'complete') {
                                node.onreadystatechange = null;
                                onSuccess({
                                    path: path,
                                    loaded: true,
                                    status: 'ok',
                                });
                            }
                        };
                    }
                    else {
                        node.onload = function () {
                            return onSuccess({
                                path: path,
                                loaded: true,
                                status: 'ok',
                            });
                        };
                    }
                    node.onerror = function (error) {
                        return onSuccess({
                            path: path,
                            loaded: false,
                            status: 'error',
                            error: error,
                        });
                    };
                    _this.doc.getElementsByTagName('head')[0].appendChild(node);
                });
            };
        /**
         * @param {?} path
         * @param {?=} rel
         * @param {?=} innerContent
         * @return {?}
         */
        LazyService.prototype.loadStyle = /**
         * @param {?} path
         * @param {?=} rel
         * @param {?=} innerContent
         * @return {?}
         */
            function (path, rel, innerContent) {
                var _this = this;
                if (rel === void 0) {
                    rel = 'stylesheet';
                }
                return new Promise(function (resolve) {
                    if (_this.list[path] === true) {
                        resolve(_this.cached[path]);
                        return;
                    }
                    _this.list[path] = true;
                    /** @type {?} */
                    var node = ( /** @type {?} */(_this.doc.createElement('link')));
                    node.rel = rel;
                    node.type = 'text/css';
                    node.href = path;
                    if (innerContent) {
                        node.innerHTML = innerContent;
                    }
                    _this.doc.getElementsByTagName('head')[0].appendChild(node);
                    /** @type {?} */
                    var item = {
                        path: path,
                        loaded: true,
                        status: 'ok',
                    };
                    _this.cached[path] = item;
                    resolve(item);
                });
            };
        LazyService.decorators = [
            { type: i0.Injectable, args: [{ providedIn: 'root' },] }
        ];
        /** @nocollapse */
        LazyService.ctorParameters = function () {
            return [
                { type: undefined, decorators: [{ type: i0.Inject, args: [i1.DOCUMENT,] }] }
            ];
        };
        /** @nocollapse */ LazyService.ngInjectableDef = i0.defineInjectable({ factory: function LazyService_Factory() { return new LazyService(i0.inject(i1.DOCUMENT)); }, token: LazyService, providedIn: "root" });
        return LazyService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.LazyService = LazyService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=nu-lazy.umd.js.map